libdap::DDXParser Class Reference

`#include <DDXParserSAX2.h>`

## Parser Actions

These methods are the 'actions' carried out by the start_element and end_element callbacks. Most of what takes place in those has been factored out to this set of functions.
class | DDXParserTest
| DDXParser (BaseTypeFactory *factory)
void | intern (const string &document, DDS *dest_dds, string &cid)
void | intern_stream (FILE *in, DDS *dds, string &cid, const string &boundary="")
| Read the DDX from a stream instead of a file.
void | intern_stream (istream &in, DDS *dds, string &cid, const string &boundary="")
static void | ddx_start_document (void *parser)
static void | ddx_end_document (void *parser)
static void | ddx_sax2_start_element (void *parser, const xmlChar *localname, const xmlChar *prefix, const xmlChar *URI, int nb_namespaces, const xmlChar **namespaces, int nb_attributes, int nb_defaulted, const xmlChar **attributes)
static void | ddx_sax2_end_element (void *parser, const xmlChar *localname, const xmlChar *prefix, const xmlChar *URI)
static void | ddx_get_characters (void *parser, const xmlChar *ch, int len)
static void | ddx_ignoreable_whitespace (void *parser, const xmlChar *ch, int len)
static void | ddx_get_cdata (void *parser, const xmlChar *value, int len)
static xmlEntityPtr | ddx_get_entity (void *parser, const xmlChar *name)
static void | ddx_fatal_error (void *parser, const char *msg,...)

## Detailed Description

Parse the XML text which encodes the network/persistent representation of the DDX object. In the current implementation, the DDX is held by an instance of the class DDS which in turn holds variables which include attributes. That is, the binary implementation of a DDX uses the old DDS, BaseType and AttrTable classes, albeit arranged in a slightly new way.

This parser for the DDX document uses the SAX interface of `libxml2`. Static methods are used as callbacks for the SAX parser. These static methods are public because making them private complicates compilation. They should not be called by anything other than the intern method. They do not throw exceptions because exceptions from within callbacks are not reliable or portable. To signal errors, the methods record information in the DDXParser object. Once the error handler is called, construction of an DDX/DDS object ends even though the SAX parser still calls the various callback functions. The parser treats warnings, errors and fatal_errors the same way; when any are found parsing stops. The intern method throws an DDXParseFailed exception if an error was found.

Note that this class uses the C++-supplied default definitions for the default and copy constructors as well as the destructor and assignment operator.

See also
  DDS

Definition at line 79 of file DDXParserSAX2.h.

## Constructor & Destructor Documentation

## DDXParser()

libdap::DDXParser::DDXParser | ( | BaseTypeFactory * | factory | ) |

inline

Definition at line 229 of file DDXParserSAX2.h.

## Member Function Documentation

## ddx_end_document()

void libdap::DDXParser::ddx_end_document | ( | void * | p | ) |

static

Clean up after finishing a parse.

Parameters

  p | The SAX parser

Definition at line 412 of file DDXParserSAX2.cc.

## ddx_fatal_error()

void libdap::DDXParser::ddx_fatal_error | ( | void * | p,
|  | const char * | msg,
|  |  | ... )

static

Process an XML fatal error. Note that SAX provides for warnings, errors and fatal errors. This code treats them all as fatal errors since there's typically no way to tell a user about the error since there's often no user interface for this software.

Parameters

  p | The SAX parser
  msg | A printf-style format string.

Definition at line 874 of file DDXParserSAX2.cc.

## ddx_get_cdata()

void libdap::DDXParser::ddx_get_cdata | ( | void * | p,
|  | const xmlChar * | value,
|  | int | len )

static

Get characters in a cdata block. DAP does not use CData, but XML in an OtherXML attribute (the value of that DAP attribute) might use it. This callback also allows CData when the parser is in the 'parser_unknown' state since some future DAP element might use it.

Definition at line 843 of file DDXParserSAX2.cc.

## ddx_get_characters()

void libdap::DDXParser::ddx_get_characters | ( | void * | p,
|  | const xmlChar * | ch,
|  | int | len )

static

Process/accumulate character data. This may be called more than once for one logical clump of data. Only save character data when processing 'value' elements; throw away all other characters.

Definition at line 802 of file DDXParserSAX2.cc.

## ddx_get_entity()

xmlEntityPtr libdap::DDXParser::ddx_get_entity | ( | void * | parser,
|  | const xmlChar * | name )

static

Handle the standard XML entities.

Parameters

  parser | The SAX parser
  name | The XML entity.

Definition at line 865 of file DDXParserSAX2.cc.

## ddx_ignoreable_whitespace()

void libdap::DDXParser::ddx_ignoreable_whitespace | ( | void * | p,
|  | const xmlChar * | ch,
|  | int | len )

static

Read whitespace that's not really important for content. This is used only for the OtherXML attribute type to preserve formating of the XML. Doing so makes the attribute value far easier to read.

Definition at line 825 of file DDXParserSAX2.cc.

## ddx_sax2_end_element()

void libdap::DDXParser::ddx_sax2_end_element | ( | void * | parser,
|  | const xmlChar * | localname,
|  | const xmlChar * | prefix,
|  | const xmlChar * | URI )

static

Definition at line 648 of file DDXParserSAX2.cc.

## ddx_sax2_start_element()

void libdap::DDXParser::ddx_sax2_start_element | ( | void * | parser,
|  | const xmlChar * | localname,
|  | const xmlChar * | prefix,
|  | const xmlChar * | URI,
|  | int | nb_namespaces,
|  | const xmlChar ** | namespaces,
|  | int | nb_attributes,
|  | int | nb_defaulted,
|  | const xmlChar ** | attributes )

static

Definition at line 444 of file DDXParserSAX2.cc.

## ddx_start_document()

void libdap::DDXParser::ddx_start_document | ( | void * | p | ) |

static

Initialize the SAX parser state object. This object is passed to each callback as a void pointer. The initial state is parser_start.

Parameters

  p | The SAX parser

Definition at line 392 of file DDXParserSAX2.cc.

## intern()

void libdap::DDXParser::intern | ( | const string & | document,
|  | DDS * | dest_dds,
|  | string & | cid )

Parse a DDX document stored in a file. The XML in the document is parsed and a binary DDX is built. This implementation stores the result in a DDS object where each instance of BaseType can hold an AttrTable object.

Parameters

  document | Read the DDX from this file.
  dest_dds | Value/result parameter; dumps the information to this DDS instance.
  cid | Value/result parameter; puts the href which references the `CID`.

Exceptions

  DDXParseFailed | Thrown if the XML document could not be read or parsed.

Definition at line 1023 of file DDXParserSAX2.cc.

## intern_stream() [1/2]

void libdap::DDXParser::intern_stream | ( | FILE * | in,
|  | DDS * | dest_dds,
|  | string & | cid,
|  | const string & | boundary = "" )

Read the DDX from a stream instead of a file.

See also
  DDXParser::intern().

Definition at line 977 of file DDXParserSAX2.cc.

## intern_stream() [2/2]

void libdap::DDXParser::intern_stream | ( | istream & | in,
|  | DDS * | dest_dds,
|  | string & | cid,
|  | const string & | boundary = "" )

Read a DDX from a C++ input stream and populate a DDS object.

Parameters

  in |
  dds |
  cid |
  boundary |

Definition at line 926 of file DDXParserSAX2.cc.

## Friends And Related Symbol Documentation

## DDXParserTest

friend class DDXParserTest

friend

Definition at line 226 of file DDXParserSAX2.h.

The documentation for this class was generated from the following files:

- DDXParserSAX2.h
- DDXParserSAX2.cc